package anonvpn.anon_next.android.service.persistence;

import android.content.SharedPreferences;

import anonvpn.anon_next.core.persistence.IConfig;
import anonvpn.anon_next.core.persistence.IPersistenceFactory;

/**
 * Created by martin on 5/22/17.
 */

public class AndroidPersistenceFactory implements IPersistenceFactory {

    private final SharedPreferences mPreferences;

    public AndroidPersistenceFactory(SharedPreferences prefs) {
        mPreferences = prefs;
    }

    @Override
    public IConfig getConfiguration() {
        return new AndroidConfig(mPreferences);
    }
}
