package anonvpn.anon_next.android.ui.main;

import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v7.app.AlertDialog;
import android.text.InputType;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;

import anon.infoservice.MixCascade;
import anonvpn.anon_next.android.R;
import anonvpn.anon_next.android.ui.VPNConnectedActivity;
import anonvpn.anon_next.android.ui.tutorial.TutorialActivity;

public class ConnectButtonFragment extends Fragment {

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        Button button = (Button) view.findViewById(R.id.connect_b_select);
        button.setOnClickListener(new ConnectButtonClickListener());
    }

    private OnFragmentInteractionListener mListener;

    public ConnectButtonFragment() {
        // Required empty public constructor
    }

    public static ConnectButtonFragment newInstance(String param1, String param2) {
        ConnectButtonFragment fragment = new ConnectButtonFragment();
        return fragment;
    }

    private class ConnectButtonClickListener implements View.OnClickListener
    {

        @Override
        public void onClick(View v)
        {
            mListener.connectToCascade();
        }
    }


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_connect_button, container, false);
    }

    public void setInteractionListener(OnFragmentInteractionListener listener) {
        mListener = listener;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        void connectToCascade();
    }
}
