//package anonvpn.anon_next.android.ui.main;
//
//import android.content.Intent;
//import android.graphics.Bitmap;
//import android.graphics.BitmapFactory;
//import android.graphics.Color;
//import android.graphics.drawable.BitmapDrawable;
//import android.graphics.drawable.Drawable;
//import android.os.Bundle;
//import android.support.v7.app.AppCompatActivity;
//import android.util.Log;
//import android.view.View;
//import android.widget.Button;
//import android.widget.TextView;
//import android.widget.Toast;
//
//import org.osmdroid.api.IMapController;
//import org.osmdroid.tileprovider.tilesource.XYTileSource;
//import org.osmdroid.util.BoundingBox;
//import org.osmdroid.util.GeoPoint;
//import org.osmdroid.views.MapView;
//import org.osmdroid.views.overlay.ItemizedIconOverlay;
//import org.osmdroid.views.overlay.ItemizedOverlay;
//import org.osmdroid.views.overlay.OverlayItem;
//import org.osmdroid.views.overlay.Polyline;
//import org.w3c.dom.Document;
//
//import java.io.StringReader;
//import java.util.ArrayList;
//
//import anon.infoservice.MixCascade;
//import anon.infoservice.MixInfo;
//import anon.util.XMLUtil;
//import anonvpn.anon_next.android.R;
//import anonvpn.anon_next.android.ui.tutorial.TutorialActivity;
//
//public class ConnectDetailActivity extends AppCompatActivity {
//
//    private final String LOGTAG = "ConnectDetailActivity";
//    private View root_view;
//    private MixCascade this_cascade;
//    private MapView mMapView;
//
//    private String intent_source;
//
//    @Override
//    protected void onCreate(Bundle savedInstanceState) {
//        super.onCreate(savedInstanceState);
////        setTheme(R.style.AppTheme_NoActionBar);
//        setTitle(R.string.connectd_label_title);
//        setContentView(R.layout.activity_connect_detail);
////        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
////        setSupportActionBar(toolbar);
//
//        // ClickedCascade.Object
//        String cascade_xml = getIntent().getStringExtra("ClickedCascade.Object");
//        intent_source = getIntent().getStringExtra("Source");
//        if (cascade_xml != null) {
//            try {
//                Document doc = anon.util.XMLUtil.readXMLDocument(new StringReader(cascade_xml));
//                this_cascade = new MixCascade(doc.getDocumentElement());
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//        } else {
//            Log.e(LOGTAG, "The clicked cascade is null!");
//            return;
//        }
//
//        setContent();
//        }
//
//    private void setContent() {
//        root_view = findViewById(R.id.activity_connect_detail);
//        TextView host = findViewById(R.id.connectd_tv_host);
//        TextView end_ip = findViewById(R.id.connectd_tv_endip);
//
//        try {
//            host.setText(this_cascade.getName());
//            end_ip.setText(this_cascade.getMixInfo(this_cascade.getNumberOfMixes() - 1).getFirstHostName());
//            setMapView();
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//
//        Button connect_button = findViewById(R.id.connect_b_select);
//        connect_button.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View view) {
//                if (intent_source.equals("MainActivity")) {
//                    Intent intent = new Intent(getApplicationContext(), MainActivity.class);
//                    try {
//                        intent.putExtra("ClickedCascade.Object", XMLUtil.toString(this_cascade));
//                    } catch (NullPointerException e) {
//                        e.printStackTrace();
//                    }
//                    startActivity(intent);
//                } else if (intent_source.equals("TutorialActivity")) {
//                    Intent intent = new Intent(getApplicationContext(), TutorialActivity.class);
//                    try {
//                        intent.putExtra("ClickedCascade.Object", XMLUtil.toString(this_cascade));
//                    } catch (NullPointerException e) {
//                        e.printStackTrace();
//                    }
//                    startActivity(intent);
//                } else {
//                    throw new RuntimeException("Unexpected intent_source: " + intent_source);
//                }
//            }
//        });
//    }
//
//    private void setMapView() {
//        //
//        // Prepare map view
//        //
//
//				mMapView = (MapView) findViewById(R.id.connect_map);
//				mMapView.setLayerType(View.LAYER_TYPE_SOFTWARE, null);
//
//				mMapView.setTileSource(new XYTileSource("MyOSM", 0, 19, 256, ".png", new String[]{"https://sk13.xyz:45443/osm_tiles/"}));
//				mMapView.setBuiltInZoomControls(true);
//				mMapView.setMultiTouchControls(true);
//				IMapController mapController = mMapView.getController();
//				mapController.setZoom(7);
//				GeoPoint startPoint = new GeoPoint(53.0383, 5.7944);
//				mapController.setCenter(startPoint);
//				drawChosenConnection(this_cascade);
//    }
//
//    public void drawChosenConnection(MixCascade connection)
//    {
//
//				this.mMapView.getOverlays().clear();
//
////				MixCascade.MixDescriptor[] mixes = connection.get
//				ArrayList<OverlayItem> markers = new ArrayList<>();
//
//				//Draw new Connection
//				ArrayList<GeoPoint> geoPoints = new ArrayList<>();
//
//				// User location, TODO: Change to GPS location?
//				geoPoints.add(new GeoPoint(51.0767496, 13.6321589));
//				OverlayItem olitem = new OverlayItem("Your location", // Name
//								"", // Description
//								geoPoints.get(0));
//				Drawable drawable = new BitmapDrawable(getResources(), resizeMapIcons("anon_jap", 50, 50));
//				olitem.setMarker(drawable);
//				markers.add(olitem);
//
//        for (int i = 0; i < connection.getNumberOfMixes(); i++) {
//            MixInfo mix = connection.getMixInfo(i);
//            GeoPoint point = GeoPoint.fromDoubleString(mix.getServiceLocation().getLatitude() +
//                    ',' + mix.getServiceLocation().getLongitude(), ',');
//						geoPoints.add(point);
//            OverlayItem _olitem = null;
//            try {
//                _olitem = new OverlayItem(mix.getServiceLocation().getCity(), // Name
//                        mix.getFirstHostName(), // Description
//                        point);
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//            Drawable _drawable = new BitmapDrawable(getResources(), resizeMapIcons("mix", 50, 50));
//						_olitem.setMarker(_drawable);
//						markers.add(_olitem);
//					}
//
//				//draw Connection-Lines
//				Polyline polyline;
//				polyline = new Polyline();
//				polyline.setPoints(geoPoints);
//				polyline.setColor(Color.RED);
//				polyline.setWidth(4);
////				polyline.setInfoWindow(new BasicInfoWindow(R.layout.bonuspack_bubble, mMapView));
////				polyline.setTitle("Polyline tapped!");
//				mMapView.getOverlays().add(polyline);
//
//				        /* OnTapListener for the Markers, shows a simple Toast. */
//				ItemizedOverlay<OverlayItem> _locationOverlay = new ItemizedIconOverlay<OverlayItem>(markers, new ItemizedIconOverlay.OnItemGestureListener<OverlayItem>()
//					{
//						@Override
//						public boolean onItemSingleTapUp(final int index, final OverlayItem item)
//							{
//								Toast.makeText(getApplicationContext(), "Location: " + item.getTitle() + "\nIP: " + item.getSnippet(), Toast.LENGTH_LONG).show();
//								return true; // We 'handled' this event.
//							}
//
//						@Override
//						public boolean onItemLongPress(final int index, final OverlayItem item)
//							{
//								Toast.makeText(getApplicationContext(), "Location: " + item.getTitle() + "\nIP: " + item.getSnippet(), Toast.LENGTH_LONG).show();
//								return false;
//							}
//					}, getApplicationContext());
//
//				mMapView.getOverlays().add(_locationOverlay);
//
//        // TODO: Zoom camera to correct bounds
//        //zoom MapCamera
//        BoundingBox boundingBox = BoundingBox.fromGeoPoints(geoPoints);
//        mMapView.zoomToBoundingBox(boundingBox, true);
//        mMapView.getController().setZoom(7);
//        mMapView.invalidate();
//    }
//
//    public Bitmap resizeMapIcons(String iconName, int width, int height)
//    {
//        Bitmap imageBitmap = BitmapFactory.decodeResource(getResources(), getResources().getIdentifier(iconName, "drawable", getApplicationContext().getPackageName()));
//        Bitmap resizedBitmap = Bitmap.createScaledBitmap(imageBitmap, width, height, false);
//        return resizedBitmap;
//    }
//}
