package anonvpn.anon_next.android.service.gui;

import anonvpn.anon_next.android.AndroidVpnService;
import anonvpn.anon_next.core.InfoService;
import anonvpn.anon_next.core.gui.IVPNInterface;
import anonvpn.anon_next.core.gui.IVPNInterfaceFactory;
import anonvpn.anon_next.core.notification.NotificationDispatcher;
import anonvpn.anon_next.core.persistence.IConfig;

/**
 * Created by martin on 5/22/17.
 */

public class AndroidGUIFactory implements IVPNInterfaceFactory {

    private final AndroidVpnService mVpnService;

    public AndroidGUIFactory(AndroidVpnService vpnService) {
        mVpnService = vpnService;
    }

    public IVPNInterface getGUIInterface(NotificationDispatcher dispatcher, IConfig config, InfoService infoService) {
        return new AndroidGUIInterface(mVpnService, dispatcher, config, infoService);
    }

}
