package anonvpn.anon_next.android.ui;

import android.graphics.Bitmap;
import android.support.v7.app.ActionBar;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import anonvpn.anon_next.android.R;

public class NetDetailActivity extends AppCompatActivity {

    TextView _title;
    TextView _security;
    TextView _enc;
    TextView _netType;
    ImageView _icon;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_net_detail);
        setTitle(getString(R.string.netd_label_title));

        // Get a support ActionBar corresponding to this toolbar
        ActionBar ab = getSupportActionBar();
        // Enable the Up button
        if (ab != null) {
            ab.setDisplayHomeAsUpEnabled(true);
        }

        setContentView(R.layout.activity_net_detail);

        String title = getIntent().getStringExtra("title");
        String enc = getIntent().getStringExtra("security");
        Bitmap bitmap = getIntent().getParcelableExtra("Bitmap");

        View view = findViewById(R.id.activity_net_detail);
        _title = (TextView) view.findViewById(R.id.netd_tv_title);
        _security = (TextView) view.findViewById(R.id.netd_tv_secure);
        _enc = (TextView) view.findViewById(R.id.netd_tv_encrypt);
        _netType = (TextView) view.findViewById(R.id.netd_tv_nettype);
        _icon = (ImageView) view.findViewById(R.id.netd_iv_icon);

        _title.setText(title);
        if(enc.equals("Nicht sicher!")){
            _security.setText(getString(R.string.netd_label_secureno));
            _netType.setText(getString(R.string.netd_label_typeopen));
        }
        else{
            _security.setText(getString(R.string.netd_label_secureyes));
            _netType.setText(getString(R.string.netd_label_typeprivate));
        }
        _enc.setText(enc);
        _icon.setImageBitmap(bitmap);

    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }

    }
}
