package anonvpn.anon_next.android.ui.tutorial;


import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;

import anonvpn.anon_next.android.R;

import anonvpn.anon_next.android.ui.tutorial.TutorialActivity;

/**
 * A simple {@link Fragment} subclass.
 */
public class WelcomeFragment extends Fragment {


    public WelcomeFragment() {
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View v = inflater.inflate(R.layout.fragment_welcome, container, false);

        Button conB = (Button) v.findViewById(R.id.welcome_b_continue);
        Button skipB = (Button) v.findViewById(R.id.welcome_b_skip);


        conB.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                ((TutorialActivity)getActivity()).setFragment(TutorialActivity.FRAGMENTID_INTROCONNECTION, true);
            }
        });

        skipB.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                ((TutorialActivity)getActivity()).endTut();
            }
        });

        return v;
    }

}
